// D5M_VIP_QSYS.v

// Generated using ACDS version 14.0 209 at 2014.11.24.16:36:32

`timescale 1 ps / 1 ps
module D5M_VIP_QSYS (
		input  wire        clk_50,                                    //                    clk_50_clk_in.clk
		input  wire        reset_n,                                   //              clk_50_clk_in_reset.reset_n
		output wire [12:0] zs_addr_from_the_sdram,                    //                       sdram_wire.addr
		output wire [1:0]  zs_ba_from_the_sdram,                      //                                 .ba
		output wire        zs_cas_n_from_the_sdram,                   //                                 .cas_n
		output wire        zs_cke_from_the_sdram,                     //                                 .cke
		output wire        zs_cs_n_from_the_sdram,                    //                                 .cs_n
		inout  wire [15:0] zs_dq_to_and_from_the_sdram,               //                                 .dq
		output wire [1:0]  zs_dqm_from_the_sdram,                     //                                 .dqm
		output wire        zs_ras_n_from_the_sdram,                   //                                 .ras_n
		output wire        zs_we_n_from_the_sdram,                    //                                 .we_n
		output wire        clk_sdram_clk,                             //                        clk_sdram.clk
		output wire        clk_vga_clk,                               //                          clk_vga.clk
		output wire [9:0]  ledr_external_connection_export,           //         ledr_external_connection.export
		input  wire [3:0]  key_external_connection_export,            //          key_external_connection.export
		input  wire [9:0]  sw_external_connection_export,             //           sw_external_connection.export
		input  wire        alt_vip_itc_0_clocked_video_vid_clk,       //      alt_vip_itc_0_clocked_video.vid_clk
		output wire [23:0] alt_vip_itc_0_clocked_video_vid_data,      //                                 .vid_data
		output wire        alt_vip_itc_0_clocked_video_underflow,     //                                 .underflow
		output wire        alt_vip_itc_0_clocked_video_vid_datavalid, //                                 .vid_datavalid
		output wire        alt_vip_itc_0_clocked_video_vid_v_sync,    //                                 .vid_v_sync
		output wire        alt_vip_itc_0_clocked_video_vid_h_sync,    //                                 .vid_h_sync
		output wire        alt_vip_itc_0_clocked_video_vid_f,         //                                 .vid_f
		output wire        alt_vip_itc_0_clocked_video_vid_h,         //                                 .vid_h
		output wire        alt_vip_itc_0_clocked_video_vid_v,         //                                 .vid_v
		input  wire [11:0] d5m_conduit_end_D,                         //                  d5m_conduit_end.D
		input  wire        d5m_conduit_end_FVAL,                      //                                 .FVAL
		input  wire        d5m_conduit_end_LVAL,                      //                                 .LVAL
		input  wire        d5m_conduit_end_PIXCLK,                    //                                 .PIXCLK
		output wire        d5m_xclkin_clk,                            //                       d5m_xclkin.clk
		output wire        d5m_i2c_sclk_external_connection_export,   // d5m_i2c_sclk_external_connection.export
		inout  wire        d5m_i2c_sdat_external_connection_export,   // d5m_i2c_sdat_external_connection.export
		output wire        d5m_trigger_external_connection_export,    //  d5m_trigger_external_connection.export
		output wire        d5m_reset_n_external_connection_export     //  d5m_reset_n_external_connection.export
	);

	wire         pll_sys_outclk2_clk;                                       // pll_sys:outclk_2 -> [clock_crossing_io_slow:m0_clk, irq_synchronizer:receiver_clk, irq_synchronizer_002:receiver_clk, irq_synchronizer_003:receiver_clk, key:clk, ledr:clk, mm_interconnect_1:pll_sys_outclk2_clk, rst_controller:clk, sw:clk, sysid:clock, timer:clk]
	wire         pll_sys_outclk0_clk;                                       // pll_sys:outclk_0 -> [alt_vip_itc_0:is_clk, alt_vip_vfb_0:clock, clock_crossing_io_slow:s0_clk, cpu:clk, d5m:clk, epcq:clk, irq_mapper:clk, irq_synchronizer:sender_clk, irq_synchronizer_001:sender_clk, irq_synchronizer_002:sender_clk, irq_synchronizer_003:sender_clk, mm_interconnect_0:pll_sys_outclk0_clk, mm_interconnect_2:pll_sys_outclk0_clk, onchip_memory2:clk, rst_controller_001:clk, rst_controller_003:clk, sdram:clk]
	wire         d5m_avalon_streaming_source_endofpacket;                   // d5m:st_eop -> alt_vip_vfb_0:din_endofpacket
	wire         d5m_avalon_streaming_source_valid;                         // d5m:st_valid -> alt_vip_vfb_0:din_valid
	wire         d5m_avalon_streaming_source_startofpacket;                 // d5m:st_sop -> alt_vip_vfb_0:din_startofpacket
	wire  [23:0] d5m_avalon_streaming_source_data;                          // d5m:st_data -> alt_vip_vfb_0:din_data
	wire         d5m_avalon_streaming_source_ready;                         // alt_vip_vfb_0:din_ready -> d5m:st_ready
	wire         alt_vip_vfb_0_dout_endofpacket;                            // alt_vip_vfb_0:dout_endofpacket -> alt_vip_itc_0:is_eop
	wire         alt_vip_vfb_0_dout_valid;                                  // alt_vip_vfb_0:dout_valid -> alt_vip_itc_0:is_valid
	wire         alt_vip_vfb_0_dout_startofpacket;                          // alt_vip_vfb_0:dout_startofpacket -> alt_vip_itc_0:is_sop
	wire  [23:0] alt_vip_vfb_0_dout_data;                                   // alt_vip_vfb_0:dout_data -> alt_vip_itc_0:is_data
	wire         alt_vip_vfb_0_dout_ready;                                  // alt_vip_itc_0:is_ready -> alt_vip_vfb_0:dout_ready
	wire         cpu_instruction_master_waitrequest;                        // mm_interconnect_0:cpu_instruction_master_waitrequest -> cpu:i_waitrequest
	wire  [24:0] cpu_instruction_master_address;                            // cpu:i_address -> mm_interconnect_0:cpu_instruction_master_address
	wire         cpu_instruction_master_read;                               // cpu:i_read -> mm_interconnect_0:cpu_instruction_master_read
	wire  [31:0] cpu_instruction_master_readdata;                           // mm_interconnect_0:cpu_instruction_master_readdata -> cpu:i_readdata
	wire         cpu_instruction_master_readdatavalid;                      // mm_interconnect_0:cpu_instruction_master_readdatavalid -> cpu:i_readdatavalid
	wire         cpu_data_master_waitrequest;                               // mm_interconnect_0:cpu_data_master_waitrequest -> cpu:d_waitrequest
	wire  [31:0] cpu_data_master_writedata;                                 // cpu:d_writedata -> mm_interconnect_0:cpu_data_master_writedata
	wire  [24:0] cpu_data_master_address;                                   // cpu:d_address -> mm_interconnect_0:cpu_data_master_address
	wire         cpu_data_master_write;                                     // cpu:d_write -> mm_interconnect_0:cpu_data_master_write
	wire         cpu_data_master_read;                                      // cpu:d_read -> mm_interconnect_0:cpu_data_master_read
	wire  [31:0] cpu_data_master_readdata;                                  // mm_interconnect_0:cpu_data_master_readdata -> cpu:d_readdata
	wire         cpu_data_master_debugaccess;                               // cpu:jtag_debug_module_debugaccess_to_roms -> mm_interconnect_0:cpu_data_master_debugaccess
	wire         cpu_data_master_readdatavalid;                             // mm_interconnect_0:cpu_data_master_readdatavalid -> cpu:d_readdatavalid
	wire   [3:0] cpu_data_master_byteenable;                                // cpu:d_byteenable -> mm_interconnect_0:cpu_data_master_byteenable
	wire         mm_interconnect_0_cpu_jtag_debug_module_waitrequest;       // cpu:jtag_debug_module_waitrequest -> mm_interconnect_0:cpu_jtag_debug_module_waitrequest
	wire  [31:0] mm_interconnect_0_cpu_jtag_debug_module_writedata;         // mm_interconnect_0:cpu_jtag_debug_module_writedata -> cpu:jtag_debug_module_writedata
	wire   [8:0] mm_interconnect_0_cpu_jtag_debug_module_address;           // mm_interconnect_0:cpu_jtag_debug_module_address -> cpu:jtag_debug_module_address
	wire         mm_interconnect_0_cpu_jtag_debug_module_write;             // mm_interconnect_0:cpu_jtag_debug_module_write -> cpu:jtag_debug_module_write
	wire         mm_interconnect_0_cpu_jtag_debug_module_read;              // mm_interconnect_0:cpu_jtag_debug_module_read -> cpu:jtag_debug_module_read
	wire  [31:0] mm_interconnect_0_cpu_jtag_debug_module_readdata;          // cpu:jtag_debug_module_readdata -> mm_interconnect_0:cpu_jtag_debug_module_readdata
	wire         mm_interconnect_0_cpu_jtag_debug_module_debugaccess;       // mm_interconnect_0:cpu_jtag_debug_module_debugaccess -> cpu:jtag_debug_module_debugaccess
	wire   [3:0] mm_interconnect_0_cpu_jtag_debug_module_byteenable;        // mm_interconnect_0:cpu_jtag_debug_module_byteenable -> cpu:jtag_debug_module_byteenable
	wire  [31:0] mm_interconnect_0_onchip_memory2_s1_writedata;             // mm_interconnect_0:onchip_memory2_s1_writedata -> onchip_memory2:writedata
	wire  [15:0] mm_interconnect_0_onchip_memory2_s1_address;               // mm_interconnect_0:onchip_memory2_s1_address -> onchip_memory2:address
	wire         mm_interconnect_0_onchip_memory2_s1_chipselect;            // mm_interconnect_0:onchip_memory2_s1_chipselect -> onchip_memory2:chipselect
	wire         mm_interconnect_0_onchip_memory2_s1_clken;                 // mm_interconnect_0:onchip_memory2_s1_clken -> onchip_memory2:clken
	wire         mm_interconnect_0_onchip_memory2_s1_write;                 // mm_interconnect_0:onchip_memory2_s1_write -> onchip_memory2:write
	wire  [31:0] mm_interconnect_0_onchip_memory2_s1_readdata;              // onchip_memory2:readdata -> mm_interconnect_0:onchip_memory2_s1_readdata
	wire   [3:0] mm_interconnect_0_onchip_memory2_s1_byteenable;            // mm_interconnect_0:onchip_memory2_s1_byteenable -> onchip_memory2:byteenable
	wire         mm_interconnect_0_clock_crossing_io_slow_s0_waitrequest;   // clock_crossing_io_slow:s0_waitrequest -> mm_interconnect_0:clock_crossing_io_slow_s0_waitrequest
	wire   [0:0] mm_interconnect_0_clock_crossing_io_slow_s0_burstcount;    // mm_interconnect_0:clock_crossing_io_slow_s0_burstcount -> clock_crossing_io_slow:s0_burstcount
	wire  [31:0] mm_interconnect_0_clock_crossing_io_slow_s0_writedata;     // mm_interconnect_0:clock_crossing_io_slow_s0_writedata -> clock_crossing_io_slow:s0_writedata
	wire   [8:0] mm_interconnect_0_clock_crossing_io_slow_s0_address;       // mm_interconnect_0:clock_crossing_io_slow_s0_address -> clock_crossing_io_slow:s0_address
	wire         mm_interconnect_0_clock_crossing_io_slow_s0_write;         // mm_interconnect_0:clock_crossing_io_slow_s0_write -> clock_crossing_io_slow:s0_write
	wire         mm_interconnect_0_clock_crossing_io_slow_s0_read;          // mm_interconnect_0:clock_crossing_io_slow_s0_read -> clock_crossing_io_slow:s0_read
	wire  [31:0] mm_interconnect_0_clock_crossing_io_slow_s0_readdata;      // clock_crossing_io_slow:s0_readdata -> mm_interconnect_0:clock_crossing_io_slow_s0_readdata
	wire         mm_interconnect_0_clock_crossing_io_slow_s0_debugaccess;   // mm_interconnect_0:clock_crossing_io_slow_s0_debugaccess -> clock_crossing_io_slow:s0_debugaccess
	wire         mm_interconnect_0_clock_crossing_io_slow_s0_readdatavalid; // clock_crossing_io_slow:s0_readdatavalid -> mm_interconnect_0:clock_crossing_io_slow_s0_readdatavalid
	wire   [3:0] mm_interconnect_0_clock_crossing_io_slow_s0_byteenable;    // mm_interconnect_0:clock_crossing_io_slow_s0_byteenable -> clock_crossing_io_slow:s0_byteenable
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest; // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;   // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;     // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;  // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;       // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;    // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire  [31:0] mm_interconnect_0_epcq_epcs_control_port_writedata;        // mm_interconnect_0:epcq_epcs_control_port_writedata -> epcq:writedata
	wire   [8:0] mm_interconnect_0_epcq_epcs_control_port_address;          // mm_interconnect_0:epcq_epcs_control_port_address -> epcq:address
	wire         mm_interconnect_0_epcq_epcs_control_port_chipselect;       // mm_interconnect_0:epcq_epcs_control_port_chipselect -> epcq:chipselect
	wire         mm_interconnect_0_epcq_epcs_control_port_write;            // mm_interconnect_0:epcq_epcs_control_port_write -> epcq:write_n
	wire         mm_interconnect_0_epcq_epcs_control_port_read;             // mm_interconnect_0:epcq_epcs_control_port_read -> epcq:read_n
	wire  [31:0] mm_interconnect_0_epcq_epcs_control_port_readdata;         // epcq:readdata -> mm_interconnect_0:epcq_epcs_control_port_readdata
	wire  [31:0] mm_interconnect_0_d5m_i2c_sclk_s1_writedata;               // mm_interconnect_0:d5m_i2c_sclk_s1_writedata -> d5m_i2c_sclk:writedata
	wire   [1:0] mm_interconnect_0_d5m_i2c_sclk_s1_address;                 // mm_interconnect_0:d5m_i2c_sclk_s1_address -> d5m_i2c_sclk:address
	wire         mm_interconnect_0_d5m_i2c_sclk_s1_chipselect;              // mm_interconnect_0:d5m_i2c_sclk_s1_chipselect -> d5m_i2c_sclk:chipselect
	wire         mm_interconnect_0_d5m_i2c_sclk_s1_write;                   // mm_interconnect_0:d5m_i2c_sclk_s1_write -> d5m_i2c_sclk:write_n
	wire  [31:0] mm_interconnect_0_d5m_i2c_sclk_s1_readdata;                // d5m_i2c_sclk:readdata -> mm_interconnect_0:d5m_i2c_sclk_s1_readdata
	wire  [31:0] mm_interconnect_0_d5m_i2c_sdat_s1_writedata;               // mm_interconnect_0:d5m_i2c_sdat_s1_writedata -> d5m_i2c_sdat:writedata
	wire   [1:0] mm_interconnect_0_d5m_i2c_sdat_s1_address;                 // mm_interconnect_0:d5m_i2c_sdat_s1_address -> d5m_i2c_sdat:address
	wire         mm_interconnect_0_d5m_i2c_sdat_s1_chipselect;              // mm_interconnect_0:d5m_i2c_sdat_s1_chipselect -> d5m_i2c_sdat:chipselect
	wire         mm_interconnect_0_d5m_i2c_sdat_s1_write;                   // mm_interconnect_0:d5m_i2c_sdat_s1_write -> d5m_i2c_sdat:write_n
	wire  [31:0] mm_interconnect_0_d5m_i2c_sdat_s1_readdata;                // d5m_i2c_sdat:readdata -> mm_interconnect_0:d5m_i2c_sdat_s1_readdata
	wire  [31:0] mm_interconnect_0_d5m_trigger_s1_writedata;                // mm_interconnect_0:d5m_trigger_s1_writedata -> d5m_trigger:writedata
	wire   [1:0] mm_interconnect_0_d5m_trigger_s1_address;                  // mm_interconnect_0:d5m_trigger_s1_address -> d5m_trigger:address
	wire         mm_interconnect_0_d5m_trigger_s1_chipselect;               // mm_interconnect_0:d5m_trigger_s1_chipselect -> d5m_trigger:chipselect
	wire         mm_interconnect_0_d5m_trigger_s1_write;                    // mm_interconnect_0:d5m_trigger_s1_write -> d5m_trigger:write_n
	wire  [31:0] mm_interconnect_0_d5m_trigger_s1_readdata;                 // d5m_trigger:readdata -> mm_interconnect_0:d5m_trigger_s1_readdata
	wire  [31:0] mm_interconnect_0_d5m_reset_n_s1_writedata;                // mm_interconnect_0:d5m_reset_n_s1_writedata -> d5m_reset_n:writedata
	wire   [1:0] mm_interconnect_0_d5m_reset_n_s1_address;                  // mm_interconnect_0:d5m_reset_n_s1_address -> d5m_reset_n:address
	wire         mm_interconnect_0_d5m_reset_n_s1_chipselect;               // mm_interconnect_0:d5m_reset_n_s1_chipselect -> d5m_reset_n:chipselect
	wire         mm_interconnect_0_d5m_reset_n_s1_write;                    // mm_interconnect_0:d5m_reset_n_s1_write -> d5m_reset_n:write_n
	wire  [31:0] mm_interconnect_0_d5m_reset_n_s1_readdata;                 // d5m_reset_n:readdata -> mm_interconnect_0:d5m_reset_n_s1_readdata
	wire   [0:0] clock_crossing_io_slow_m0_burstcount;                      // clock_crossing_io_slow:m0_burstcount -> mm_interconnect_1:clock_crossing_io_slow_m0_burstcount
	wire         clock_crossing_io_slow_m0_waitrequest;                     // mm_interconnect_1:clock_crossing_io_slow_m0_waitrequest -> clock_crossing_io_slow:m0_waitrequest
	wire   [8:0] clock_crossing_io_slow_m0_address;                         // clock_crossing_io_slow:m0_address -> mm_interconnect_1:clock_crossing_io_slow_m0_address
	wire  [31:0] clock_crossing_io_slow_m0_writedata;                       // clock_crossing_io_slow:m0_writedata -> mm_interconnect_1:clock_crossing_io_slow_m0_writedata
	wire         clock_crossing_io_slow_m0_write;                           // clock_crossing_io_slow:m0_write -> mm_interconnect_1:clock_crossing_io_slow_m0_write
	wire         clock_crossing_io_slow_m0_read;                            // clock_crossing_io_slow:m0_read -> mm_interconnect_1:clock_crossing_io_slow_m0_read
	wire  [31:0] clock_crossing_io_slow_m0_readdata;                        // mm_interconnect_1:clock_crossing_io_slow_m0_readdata -> clock_crossing_io_slow:m0_readdata
	wire         clock_crossing_io_slow_m0_debugaccess;                     // clock_crossing_io_slow:m0_debugaccess -> mm_interconnect_1:clock_crossing_io_slow_m0_debugaccess
	wire   [3:0] clock_crossing_io_slow_m0_byteenable;                      // clock_crossing_io_slow:m0_byteenable -> mm_interconnect_1:clock_crossing_io_slow_m0_byteenable
	wire         clock_crossing_io_slow_m0_readdatavalid;                   // mm_interconnect_1:clock_crossing_io_slow_m0_readdatavalid -> clock_crossing_io_slow:m0_readdatavalid
	wire  [15:0] mm_interconnect_1_timer_s1_writedata;                      // mm_interconnect_1:timer_s1_writedata -> timer:writedata
	wire   [2:0] mm_interconnect_1_timer_s1_address;                        // mm_interconnect_1:timer_s1_address -> timer:address
	wire         mm_interconnect_1_timer_s1_chipselect;                     // mm_interconnect_1:timer_s1_chipselect -> timer:chipselect
	wire         mm_interconnect_1_timer_s1_write;                          // mm_interconnect_1:timer_s1_write -> timer:write_n
	wire  [15:0] mm_interconnect_1_timer_s1_readdata;                       // timer:readdata -> mm_interconnect_1:timer_s1_readdata
	wire   [0:0] mm_interconnect_1_sysid_control_slave_address;             // mm_interconnect_1:sysid_control_slave_address -> sysid:address
	wire  [31:0] mm_interconnect_1_sysid_control_slave_readdata;            // sysid:readdata -> mm_interconnect_1:sysid_control_slave_readdata
	wire  [31:0] mm_interconnect_1_sw_s1_writedata;                         // mm_interconnect_1:sw_s1_writedata -> sw:writedata
	wire   [1:0] mm_interconnect_1_sw_s1_address;                           // mm_interconnect_1:sw_s1_address -> sw:address
	wire         mm_interconnect_1_sw_s1_chipselect;                        // mm_interconnect_1:sw_s1_chipselect -> sw:chipselect
	wire         mm_interconnect_1_sw_s1_write;                             // mm_interconnect_1:sw_s1_write -> sw:write_n
	wire  [31:0] mm_interconnect_1_sw_s1_readdata;                          // sw:readdata -> mm_interconnect_1:sw_s1_readdata
	wire  [31:0] mm_interconnect_1_key_s1_writedata;                        // mm_interconnect_1:key_s1_writedata -> key:writedata
	wire   [1:0] mm_interconnect_1_key_s1_address;                          // mm_interconnect_1:key_s1_address -> key:address
	wire         mm_interconnect_1_key_s1_chipselect;                       // mm_interconnect_1:key_s1_chipselect -> key:chipselect
	wire         mm_interconnect_1_key_s1_write;                            // mm_interconnect_1:key_s1_write -> key:write_n
	wire  [31:0] mm_interconnect_1_key_s1_readdata;                         // key:readdata -> mm_interconnect_1:key_s1_readdata
	wire  [31:0] mm_interconnect_1_ledr_s1_writedata;                       // mm_interconnect_1:ledr_s1_writedata -> ledr:writedata
	wire   [1:0] mm_interconnect_1_ledr_s1_address;                         // mm_interconnect_1:ledr_s1_address -> ledr:address
	wire         mm_interconnect_1_ledr_s1_chipselect;                      // mm_interconnect_1:ledr_s1_chipselect -> ledr:chipselect
	wire         mm_interconnect_1_ledr_s1_write;                           // mm_interconnect_1:ledr_s1_write -> ledr:write_n
	wire  [31:0] mm_interconnect_1_ledr_s1_readdata;                        // ledr:readdata -> mm_interconnect_1:ledr_s1_readdata
	wire   [5:0] alt_vip_vfb_0_read_master_burstcount;                      // alt_vip_vfb_0:read_master_av_burstcount -> mm_interconnect_2:alt_vip_vfb_0_read_master_burstcount
	wire         alt_vip_vfb_0_read_master_waitrequest;                     // mm_interconnect_2:alt_vip_vfb_0_read_master_waitrequest -> alt_vip_vfb_0:read_master_av_waitrequest
	wire  [31:0] alt_vip_vfb_0_read_master_address;                         // alt_vip_vfb_0:read_master_av_address -> mm_interconnect_2:alt_vip_vfb_0_read_master_address
	wire         alt_vip_vfb_0_read_master_read;                            // alt_vip_vfb_0:read_master_av_read -> mm_interconnect_2:alt_vip_vfb_0_read_master_read
	wire  [31:0] alt_vip_vfb_0_read_master_readdata;                        // mm_interconnect_2:alt_vip_vfb_0_read_master_readdata -> alt_vip_vfb_0:read_master_av_readdata
	wire         alt_vip_vfb_0_read_master_readdatavalid;                   // mm_interconnect_2:alt_vip_vfb_0_read_master_readdatavalid -> alt_vip_vfb_0:read_master_av_readdatavalid
	wire   [5:0] alt_vip_vfb_0_write_master_burstcount;                     // alt_vip_vfb_0:write_master_av_burstcount -> mm_interconnect_2:alt_vip_vfb_0_write_master_burstcount
	wire         alt_vip_vfb_0_write_master_waitrequest;                    // mm_interconnect_2:alt_vip_vfb_0_write_master_waitrequest -> alt_vip_vfb_0:write_master_av_waitrequest
	wire  [31:0] alt_vip_vfb_0_write_master_writedata;                      // alt_vip_vfb_0:write_master_av_writedata -> mm_interconnect_2:alt_vip_vfb_0_write_master_writedata
	wire  [31:0] alt_vip_vfb_0_write_master_address;                        // alt_vip_vfb_0:write_master_av_address -> mm_interconnect_2:alt_vip_vfb_0_write_master_address
	wire         alt_vip_vfb_0_write_master_write;                          // alt_vip_vfb_0:write_master_av_write -> mm_interconnect_2:alt_vip_vfb_0_write_master_write
	wire         mm_interconnect_2_sdram_s1_waitrequest;                    // sdram:za_waitrequest -> mm_interconnect_2:sdram_s1_waitrequest
	wire  [15:0] mm_interconnect_2_sdram_s1_writedata;                      // mm_interconnect_2:sdram_s1_writedata -> sdram:az_data
	wire  [24:0] mm_interconnect_2_sdram_s1_address;                        // mm_interconnect_2:sdram_s1_address -> sdram:az_addr
	wire         mm_interconnect_2_sdram_s1_chipselect;                     // mm_interconnect_2:sdram_s1_chipselect -> sdram:az_cs
	wire         mm_interconnect_2_sdram_s1_write;                          // mm_interconnect_2:sdram_s1_write -> sdram:az_wr_n
	wire         mm_interconnect_2_sdram_s1_read;                           // mm_interconnect_2:sdram_s1_read -> sdram:az_rd_n
	wire  [15:0] mm_interconnect_2_sdram_s1_readdata;                       // sdram:za_data -> mm_interconnect_2:sdram_s1_readdata
	wire         mm_interconnect_2_sdram_s1_readdatavalid;                  // sdram:za_valid -> mm_interconnect_2:sdram_s1_readdatavalid
	wire   [1:0] mm_interconnect_2_sdram_s1_byteenable;                     // mm_interconnect_2:sdram_s1_byteenable -> sdram:az_be_n
	wire         irq_mapper_receiver4_irq;                                  // epcq:irq -> irq_mapper:receiver4_irq
	wire  [31:0] cpu_d_irq_irq;                                             // irq_mapper:sender_irq -> cpu:d_irq
	wire         irq_mapper_receiver0_irq;                                  // irq_synchronizer:sender_irq -> irq_mapper:receiver0_irq
	wire   [0:0] irq_synchronizer_receiver_irq;                             // timer:irq -> irq_synchronizer:receiver_irq
	wire         irq_mapper_receiver1_irq;                                  // irq_synchronizer_001:sender_irq -> irq_mapper:receiver1_irq
	wire   [0:0] irq_synchronizer_001_receiver_irq;                         // jtag_uart:av_irq -> irq_synchronizer_001:receiver_irq
	wire         irq_mapper_receiver2_irq;                                  // irq_synchronizer_002:sender_irq -> irq_mapper:receiver2_irq
	wire   [0:0] irq_synchronizer_002_receiver_irq;                         // sw:irq -> irq_synchronizer_002:receiver_irq
	wire         irq_mapper_receiver3_irq;                                  // irq_synchronizer_003:sender_irq -> irq_mapper:receiver3_irq
	wire   [0:0] irq_synchronizer_003_receiver_irq;                         // key:irq -> irq_synchronizer_003:receiver_irq
	wire         rst_controller_reset_out_reset;                            // rst_controller:reset_out -> [clock_crossing_io_slow:m0_reset, irq_synchronizer:receiver_reset, irq_synchronizer_002:receiver_reset, irq_synchronizer_003:receiver_reset, key:reset_n, ledr:reset_n, mm_interconnect_1:clock_crossing_io_slow_m0_reset_reset_bridge_in_reset_reset, sw:reset_n, sysid:reset_n, timer:reset_n]
	wire         rst_controller_001_reset_out_reset;                        // rst_controller_001:reset_out -> [alt_vip_itc_0:rst, alt_vip_vfb_0:reset, epcq:reset_n, mm_interconnect_0:onchip_memory2_reset1_reset_bridge_in_reset_reset, mm_interconnect_2:alt_vip_vfb_0_reset_reset_bridge_in_reset_reset, onchip_memory2:reset, rst_translator:in_reset, sdram:reset_n]
	wire         rst_controller_001_reset_out_reset_req;                    // rst_controller_001:reset_req -> [epcq:reset_req, onchip_memory2:reset_req, rst_translator:reset_req_in]
	wire         cpu_jtag_debug_module_reset_reset;                         // cpu:jtag_debug_module_resetrequest -> [rst_controller_001:reset_in1, rst_controller_002:reset_in1]
	wire         rst_controller_002_reset_out_reset;                        // rst_controller_002:reset_out -> [d5m_i2c_sclk:reset_n, d5m_i2c_sdat:reset_n, d5m_reset_n:reset_n, d5m_trigger:reset_n, irq_synchronizer_001:receiver_reset, jtag_uart:rst_n, mm_interconnect_0:jtag_uart_reset_reset_bridge_in_reset_reset]
	wire         rst_controller_003_reset_out_reset;                        // rst_controller_003:reset_out -> [clock_crossing_io_slow:s0_reset, cpu:reset_n, d5m:reset_n, irq_mapper:reset, irq_synchronizer:sender_reset, irq_synchronizer_001:sender_reset, irq_synchronizer_002:sender_reset, irq_synchronizer_003:sender_reset, mm_interconnect_0:cpu_reset_n_reset_bridge_in_reset_reset, rst_translator_001:in_reset]
	wire         rst_controller_003_reset_out_reset_req;                    // rst_controller_003:reset_req -> [cpu:reset_req, rst_translator_001:reset_req_in]
	wire         rst_controller_004_reset_out_reset;                        // rst_controller_004:reset_out -> pll_sys:rst

	D5M_VIP_QSYS_timer timer (
		.clk        (pll_sys_outclk2_clk),                   //   clk.clk
		.reset_n    (~rst_controller_reset_out_reset),       // reset.reset_n
		.address    (mm_interconnect_1_timer_s1_address),    //    s1.address
		.writedata  (mm_interconnect_1_timer_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_1_timer_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_1_timer_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_1_timer_s1_write),     //      .write_n
		.irq        (irq_synchronizer_receiver_irq)          //   irq.irq
	);

	D5M_VIP_QSYS_onchip_memory2 onchip_memory2 (
		.clk        (pll_sys_outclk0_clk),                            //   clk1.clk
		.address    (mm_interconnect_0_onchip_memory2_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_onchip_memory2_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_onchip_memory2_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_onchip_memory2_s1_write),      //       .write
		.readdata   (mm_interconnect_0_onchip_memory2_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_onchip_memory2_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_onchip_memory2_s1_byteenable), //       .byteenable
		.reset      (rst_controller_001_reset_out_reset),             // reset1.reset
		.reset_req  (rst_controller_001_reset_out_reset_req)          //       .reset_req
	);

	D5M_VIP_QSYS_sdram sdram (
		.clk            (pll_sys_outclk0_clk),                      //   clk.clk
		.reset_n        (~rst_controller_001_reset_out_reset),      // reset.reset_n
		.az_addr        (mm_interconnect_2_sdram_s1_address),       //    s1.address
		.az_be_n        (~mm_interconnect_2_sdram_s1_byteenable),   //      .byteenable_n
		.az_cs          (mm_interconnect_2_sdram_s1_chipselect),    //      .chipselect
		.az_data        (mm_interconnect_2_sdram_s1_writedata),     //      .writedata
		.az_rd_n        (~mm_interconnect_2_sdram_s1_read),         //      .read_n
		.az_wr_n        (~mm_interconnect_2_sdram_s1_write),        //      .write_n
		.za_data        (mm_interconnect_2_sdram_s1_readdata),      //      .readdata
		.za_valid       (mm_interconnect_2_sdram_s1_readdatavalid), //      .readdatavalid
		.za_waitrequest (mm_interconnect_2_sdram_s1_waitrequest),   //      .waitrequest
		.zs_addr        (zs_addr_from_the_sdram),                   //  wire.export
		.zs_ba          (zs_ba_from_the_sdram),                     //      .export
		.zs_cas_n       (zs_cas_n_from_the_sdram),                  //      .export
		.zs_cke         (zs_cke_from_the_sdram),                    //      .export
		.zs_cs_n        (zs_cs_n_from_the_sdram),                   //      .export
		.zs_dq          (zs_dq_to_and_from_the_sdram),              //      .export
		.zs_dqm         (zs_dqm_from_the_sdram),                    //      .export
		.zs_ras_n       (zs_ras_n_from_the_sdram),                  //      .export
		.zs_we_n        (zs_we_n_from_the_sdram)                    //      .export
	);

	D5M_VIP_QSYS_jtag_uart jtag_uart (
		.clk            (clk_50),                                                    //               clk.clk
		.rst_n          (~rst_controller_002_reset_out_reset),                       //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_synchronizer_001_receiver_irq)                          //               irq.irq
	);

	altera_avalon_mm_clock_crossing_bridge #(
		.DATA_WIDTH          (32),
		.SYMBOL_WIDTH        (8),
		.HDL_ADDR_WIDTH      (9),
		.BURSTCOUNT_WIDTH    (1),
		.COMMAND_FIFO_DEPTH  (32),
		.RESPONSE_FIFO_DEPTH (256),
		.MASTER_SYNC_DEPTH   (3),
		.SLAVE_SYNC_DEPTH    (3)
	) clock_crossing_io_slow (
		.m0_clk           (pll_sys_outclk2_clk),                                       //   m0_clk.clk
		.m0_reset         (rst_controller_reset_out_reset),                            // m0_reset.reset
		.s0_clk           (pll_sys_outclk0_clk),                                       //   s0_clk.clk
		.s0_reset         (rst_controller_003_reset_out_reset),                        // s0_reset.reset
		.s0_waitrequest   (mm_interconnect_0_clock_crossing_io_slow_s0_waitrequest),   //       s0.waitrequest
		.s0_readdata      (mm_interconnect_0_clock_crossing_io_slow_s0_readdata),      //         .readdata
		.s0_readdatavalid (mm_interconnect_0_clock_crossing_io_slow_s0_readdatavalid), //         .readdatavalid
		.s0_burstcount    (mm_interconnect_0_clock_crossing_io_slow_s0_burstcount),    //         .burstcount
		.s0_writedata     (mm_interconnect_0_clock_crossing_io_slow_s0_writedata),     //         .writedata
		.s0_address       (mm_interconnect_0_clock_crossing_io_slow_s0_address),       //         .address
		.s0_write         (mm_interconnect_0_clock_crossing_io_slow_s0_write),         //         .write
		.s0_read          (mm_interconnect_0_clock_crossing_io_slow_s0_read),          //         .read
		.s0_byteenable    (mm_interconnect_0_clock_crossing_io_slow_s0_byteenable),    //         .byteenable
		.s0_debugaccess   (mm_interconnect_0_clock_crossing_io_slow_s0_debugaccess),   //         .debugaccess
		.m0_waitrequest   (clock_crossing_io_slow_m0_waitrequest),                     //       m0.waitrequest
		.m0_readdata      (clock_crossing_io_slow_m0_readdata),                        //         .readdata
		.m0_readdatavalid (clock_crossing_io_slow_m0_readdatavalid),                   //         .readdatavalid
		.m0_burstcount    (clock_crossing_io_slow_m0_burstcount),                      //         .burstcount
		.m0_writedata     (clock_crossing_io_slow_m0_writedata),                       //         .writedata
		.m0_address       (clock_crossing_io_slow_m0_address),                         //         .address
		.m0_write         (clock_crossing_io_slow_m0_write),                           //         .write
		.m0_read          (clock_crossing_io_slow_m0_read),                            //         .read
		.m0_byteenable    (clock_crossing_io_slow_m0_byteenable),                      //         .byteenable
		.m0_debugaccess   (clock_crossing_io_slow_m0_debugaccess)                      //         .debugaccess
	);

	D5M_VIP_QSYS_cpu cpu (
		.clk                                   (pll_sys_outclk0_clk),                                 //                       clk.clk
		.reset_n                               (~rst_controller_003_reset_out_reset),                 //                   reset_n.reset_n
		.reset_req                             (rst_controller_003_reset_out_reset_req),              //                          .reset_req
		.d_address                             (cpu_data_master_address),                             //               data_master.address
		.d_byteenable                          (cpu_data_master_byteenable),                          //                          .byteenable
		.d_read                                (cpu_data_master_read),                                //                          .read
		.d_readdata                            (cpu_data_master_readdata),                            //                          .readdata
		.d_waitrequest                         (cpu_data_master_waitrequest),                         //                          .waitrequest
		.d_write                               (cpu_data_master_write),                               //                          .write
		.d_writedata                           (cpu_data_master_writedata),                           //                          .writedata
		.d_readdatavalid                       (cpu_data_master_readdatavalid),                       //                          .readdatavalid
		.jtag_debug_module_debugaccess_to_roms (cpu_data_master_debugaccess),                         //                          .debugaccess
		.i_address                             (cpu_instruction_master_address),                      //        instruction_master.address
		.i_read                                (cpu_instruction_master_read),                         //                          .read
		.i_readdata                            (cpu_instruction_master_readdata),                     //                          .readdata
		.i_waitrequest                         (cpu_instruction_master_waitrequest),                  //                          .waitrequest
		.i_readdatavalid                       (cpu_instruction_master_readdatavalid),                //                          .readdatavalid
		.d_irq                                 (cpu_d_irq_irq),                                       //                     d_irq.irq
		.jtag_debug_module_resetrequest        (cpu_jtag_debug_module_reset_reset),                   //   jtag_debug_module_reset.reset
		.jtag_debug_module_address             (mm_interconnect_0_cpu_jtag_debug_module_address),     //         jtag_debug_module.address
		.jtag_debug_module_byteenable          (mm_interconnect_0_cpu_jtag_debug_module_byteenable),  //                          .byteenable
		.jtag_debug_module_debugaccess         (mm_interconnect_0_cpu_jtag_debug_module_debugaccess), //                          .debugaccess
		.jtag_debug_module_read                (mm_interconnect_0_cpu_jtag_debug_module_read),        //                          .read
		.jtag_debug_module_readdata            (mm_interconnect_0_cpu_jtag_debug_module_readdata),    //                          .readdata
		.jtag_debug_module_waitrequest         (mm_interconnect_0_cpu_jtag_debug_module_waitrequest), //                          .waitrequest
		.jtag_debug_module_write               (mm_interconnect_0_cpu_jtag_debug_module_write),       //                          .write
		.jtag_debug_module_writedata           (mm_interconnect_0_cpu_jtag_debug_module_writedata),   //                          .writedata
		.no_ci_readra                          ()                                                     // custom_instruction_master.readra
	);

	D5M_VIP_QSYS_sysid sysid (
		.clock    (pll_sys_outclk2_clk),                            //           clk.clk
		.reset_n  (~rst_controller_reset_out_reset),                //         reset.reset_n
		.readdata (mm_interconnect_1_sysid_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_1_sysid_control_slave_address)   //              .address
	);

	D5M_VIP_QSYS_pll_sys pll_sys (
		.refclk   (clk_50),                             //  refclk.clk
		.rst      (rst_controller_004_reset_out_reset), //   reset.reset
		.outclk_0 (pll_sys_outclk0_clk),                // outclk0.clk
		.outclk_1 (clk_sdram_clk),                      // outclk1.clk
		.outclk_2 (pll_sys_outclk2_clk),                // outclk2.clk
		.outclk_3 (clk_vga_clk),                        // outclk3.clk
		.outclk_4 (d5m_xclkin_clk),                     // outclk4.clk
		.locked   ()                                    //  locked.export
	);

	D5M_VIP_QSYS_sw sw (
		.clk        (pll_sys_outclk2_clk),                //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),    //               reset.reset_n
		.address    (mm_interconnect_1_sw_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_sw_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_sw_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_sw_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_sw_s1_readdata),   //                    .readdata
		.in_port    (sw_external_connection_export),      // external_connection.export
		.irq        (irq_synchronizer_002_receiver_irq)   //                 irq.irq
	);

	D5M_VIP_QSYS_key key (
		.clk        (pll_sys_outclk2_clk),                 //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),     //               reset.reset_n
		.address    (mm_interconnect_1_key_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_key_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_key_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_key_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_key_s1_readdata),   //                    .readdata
		.in_port    (key_external_connection_export),      // external_connection.export
		.irq        (irq_synchronizer_003_receiver_irq)    //                 irq.irq
	);

	D5M_VIP_QSYS_ledr ledr (
		.clk        (pll_sys_outclk2_clk),                  //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),      //               reset.reset_n
		.address    (mm_interconnect_1_ledr_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_ledr_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_ledr_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_ledr_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_ledr_s1_readdata),   //                    .readdata
		.out_port   (ledr_external_connection_export)       // external_connection.export
	);

	D5M_VIP_QSYS_epcq epcq (
		.clk           (pll_sys_outclk0_clk),                                 //               clk.clk
		.reset_n       (~rst_controller_001_reset_out_reset),                 //             reset.reset_n
		.reset_req     (rst_controller_001_reset_out_reset_req),              //                  .reset_req
		.address       (mm_interconnect_0_epcq_epcs_control_port_address),    // epcs_control_port.address
		.chipselect    (mm_interconnect_0_epcq_epcs_control_port_chipselect), //                  .chipselect
		.dataavailable (),                                                    //                  .dataavailable
		.endofpacket   (),                                                    //                  .endofpacket
		.read_n        (~mm_interconnect_0_epcq_epcs_control_port_read),      //                  .read_n
		.readdata      (mm_interconnect_0_epcq_epcs_control_port_readdata),   //                  .readdata
		.readyfordata  (),                                                    //                  .readyfordata
		.write_n       (~mm_interconnect_0_epcq_epcs_control_port_write),     //                  .write_n
		.writedata     (mm_interconnect_0_epcq_epcs_control_port_writedata),  //                  .writedata
		.irq           (irq_mapper_receiver4_irq)                             //               irq.irq
	);

	alt_vipitc131_IS2Vid #(
		.NUMBER_OF_COLOUR_PLANES       (3),
		.COLOUR_PLANES_ARE_IN_PARALLEL (1),
		.BPS                           (8),
		.INTERLACED                    (0),
		.H_ACTIVE_PIXELS               (640),
		.V_ACTIVE_LINES                (480),
		.ACCEPT_COLOURS_IN_SEQ         (0),
		.FIFO_DEPTH                    (6399),
		.CLOCKS_ARE_SAME               (0),
		.USE_CONTROL                   (0),
		.NO_OF_MODES                   (1),
		.THRESHOLD                     (4799),
		.STD_WIDTH                     (1),
		.GENERATE_SYNC                 (0),
		.USE_EMBEDDED_SYNCS            (0),
		.AP_LINE                       (0),
		.V_BLANK                       (0),
		.H_BLANK                       (0),
		.H_SYNC_LENGTH                 (96),
		.H_FRONT_PORCH                 (16),
		.H_BACK_PORCH                  (49),
		.V_SYNC_LENGTH                 (2),
		.V_FRONT_PORCH                 (10),
		.V_BACK_PORCH                  (33),
		.F_RISING_EDGE                 (0),
		.F_FALLING_EDGE                (0),
		.FIELD0_V_RISING_EDGE          (0),
		.FIELD0_V_BLANK                (0),
		.FIELD0_V_SYNC_LENGTH          (0),
		.FIELD0_V_FRONT_PORCH          (0),
		.FIELD0_V_BACK_PORCH           (0),
		.ANC_LINE                      (0),
		.FIELD0_ANC_LINE               (0)
	) alt_vip_itc_0 (
		.is_clk        (pll_sys_outclk0_clk),                       //       is_clk_rst.clk
		.rst           (rst_controller_001_reset_out_reset),        // is_clk_rst_reset.reset
		.is_data       (alt_vip_vfb_0_dout_data),                   //              din.data
		.is_valid      (alt_vip_vfb_0_dout_valid),                  //                 .valid
		.is_ready      (alt_vip_vfb_0_dout_ready),                  //                 .ready
		.is_sop        (alt_vip_vfb_0_dout_startofpacket),          //                 .startofpacket
		.is_eop        (alt_vip_vfb_0_dout_endofpacket),            //                 .endofpacket
		.vid_clk       (alt_vip_itc_0_clocked_video_vid_clk),       //    clocked_video.export
		.vid_data      (alt_vip_itc_0_clocked_video_vid_data),      //                 .export
		.underflow     (alt_vip_itc_0_clocked_video_underflow),     //                 .export
		.vid_datavalid (alt_vip_itc_0_clocked_video_vid_datavalid), //                 .export
		.vid_v_sync    (alt_vip_itc_0_clocked_video_vid_v_sync),    //                 .export
		.vid_h_sync    (alt_vip_itc_0_clocked_video_vid_h_sync),    //                 .export
		.vid_f         (alt_vip_itc_0_clocked_video_vid_f),         //                 .export
		.vid_h         (alt_vip_itc_0_clocked_video_vid_h),         //                 .export
		.vid_v         (alt_vip_itc_0_clocked_video_vid_v)          //                 .export
	);

	TERASIC_CAMERA #(
		.VIDEO_W (640),
		.VIDEO_H (480)
	) d5m (
		.clk           (pll_sys_outclk0_clk),                       //             clock_reset.clk
		.reset_n       (~rst_controller_003_reset_out_reset),       //       clock_reset_reset.reset_n
		.CAMERA_D      (d5m_conduit_end_D),                         //             conduit_end.export
		.CAMERA_FVAL   (d5m_conduit_end_FVAL),                      //                        .export
		.CAMERA_LVAL   (d5m_conduit_end_LVAL),                      //                        .export
		.CAMERA_PIXCLK (d5m_conduit_end_PIXCLK),                    //                        .export
		.st_data       (d5m_avalon_streaming_source_data),          // avalon_streaming_source.data
		.st_sop        (d5m_avalon_streaming_source_startofpacket), //                        .startofpacket
		.st_eop        (d5m_avalon_streaming_source_endofpacket),   //                        .endofpacket
		.st_ready      (d5m_avalon_streaming_source_ready),         //                        .ready
		.st_valid      (d5m_avalon_streaming_source_valid)          //                        .valid
	);

	D5M_VIP_QSYS_d5m_i2c_sclk d5m_i2c_sclk (
		.clk        (clk_50),                                       //                 clk.clk
		.reset_n    (~rst_controller_002_reset_out_reset),          //               reset.reset_n
		.address    (mm_interconnect_0_d5m_i2c_sclk_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_d5m_i2c_sclk_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_d5m_i2c_sclk_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_d5m_i2c_sclk_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_d5m_i2c_sclk_s1_readdata),   //                    .readdata
		.out_port   (d5m_i2c_sclk_external_connection_export)       // external_connection.export
	);

	D5M_VIP_QSYS_d5m_i2c_sdat d5m_i2c_sdat (
		.clk        (clk_50),                                       //                 clk.clk
		.reset_n    (~rst_controller_002_reset_out_reset),          //               reset.reset_n
		.address    (mm_interconnect_0_d5m_i2c_sdat_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_d5m_i2c_sdat_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_d5m_i2c_sdat_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_d5m_i2c_sdat_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_d5m_i2c_sdat_s1_readdata),   //                    .readdata
		.bidir_port (d5m_i2c_sdat_external_connection_export)       // external_connection.export
	);

	D5M_VIP_QSYS_d5m_i2c_sclk d5m_trigger (
		.clk        (clk_50),                                      //                 clk.clk
		.reset_n    (~rst_controller_002_reset_out_reset),         //               reset.reset_n
		.address    (mm_interconnect_0_d5m_trigger_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_d5m_trigger_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_d5m_trigger_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_d5m_trigger_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_d5m_trigger_s1_readdata),   //                    .readdata
		.out_port   (d5m_trigger_external_connection_export)       // external_connection.export
	);

	D5M_VIP_QSYS_d5m_reset_n d5m_reset_n (
		.clk        (clk_50),                                      //                 clk.clk
		.reset_n    (~rst_controller_002_reset_out_reset),         //               reset.reset_n
		.address    (mm_interconnect_0_d5m_reset_n_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_d5m_reset_n_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_d5m_reset_n_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_d5m_reset_n_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_d5m_reset_n_s1_readdata),   //                    .readdata
		.out_port   (d5m_reset_n_external_connection_export)       // external_connection.export
	);

	D5M_VIP_QSYS_alt_vip_vfb_0 alt_vip_vfb_0 (
		.clock                        (pll_sys_outclk0_clk),                       //        clock.clk
		.reset                        (rst_controller_001_reset_out_reset),        //        reset.reset
		.din_ready                    (d5m_avalon_streaming_source_ready),         //          din.ready
		.din_valid                    (d5m_avalon_streaming_source_valid),         //             .valid
		.din_data                     (d5m_avalon_streaming_source_data),          //             .data
		.din_startofpacket            (d5m_avalon_streaming_source_startofpacket), //             .startofpacket
		.din_endofpacket              (d5m_avalon_streaming_source_endofpacket),   //             .endofpacket
		.dout_ready                   (alt_vip_vfb_0_dout_ready),                  //         dout.ready
		.dout_valid                   (alt_vip_vfb_0_dout_valid),                  //             .valid
		.dout_data                    (alt_vip_vfb_0_dout_data),                   //             .data
		.dout_startofpacket           (alt_vip_vfb_0_dout_startofpacket),          //             .startofpacket
		.dout_endofpacket             (alt_vip_vfb_0_dout_endofpacket),            //             .endofpacket
		.read_master_av_address       (alt_vip_vfb_0_read_master_address),         //  read_master.address
		.read_master_av_read          (alt_vip_vfb_0_read_master_read),            //             .read
		.read_master_av_waitrequest   (alt_vip_vfb_0_read_master_waitrequest),     //             .waitrequest
		.read_master_av_readdatavalid (alt_vip_vfb_0_read_master_readdatavalid),   //             .readdatavalid
		.read_master_av_readdata      (alt_vip_vfb_0_read_master_readdata),        //             .readdata
		.read_master_av_burstcount    (alt_vip_vfb_0_read_master_burstcount),      //             .burstcount
		.write_master_av_address      (alt_vip_vfb_0_write_master_address),        // write_master.address
		.write_master_av_write        (alt_vip_vfb_0_write_master_write),          //             .write
		.write_master_av_writedata    (alt_vip_vfb_0_write_master_writedata),      //             .writedata
		.write_master_av_waitrequest  (alt_vip_vfb_0_write_master_waitrequest),    //             .waitrequest
		.write_master_av_burstcount   (alt_vip_vfb_0_write_master_burstcount)      //             .burstcount
	);

	D5M_VIP_QSYS_mm_interconnect_0 mm_interconnect_0 (
		.clk_50_clk_clk                                    (clk_50),                                                    //                                  clk_50_clk.clk
		.pll_sys_outclk0_clk                               (pll_sys_outclk0_clk),                                       //                             pll_sys_outclk0.clk
		.cpu_reset_n_reset_bridge_in_reset_reset           (rst_controller_003_reset_out_reset),                        //           cpu_reset_n_reset_bridge_in_reset.reset
		.jtag_uart_reset_reset_bridge_in_reset_reset       (rst_controller_002_reset_out_reset),                        //       jtag_uart_reset_reset_bridge_in_reset.reset
		.onchip_memory2_reset1_reset_bridge_in_reset_reset (rst_controller_001_reset_out_reset),                        // onchip_memory2_reset1_reset_bridge_in_reset.reset
		.cpu_data_master_address                           (cpu_data_master_address),                                   //                             cpu_data_master.address
		.cpu_data_master_waitrequest                       (cpu_data_master_waitrequest),                               //                                            .waitrequest
		.cpu_data_master_byteenable                        (cpu_data_master_byteenable),                                //                                            .byteenable
		.cpu_data_master_read                              (cpu_data_master_read),                                      //                                            .read
		.cpu_data_master_readdata                          (cpu_data_master_readdata),                                  //                                            .readdata
		.cpu_data_master_readdatavalid                     (cpu_data_master_readdatavalid),                             //                                            .readdatavalid
		.cpu_data_master_write                             (cpu_data_master_write),                                     //                                            .write
		.cpu_data_master_writedata                         (cpu_data_master_writedata),                                 //                                            .writedata
		.cpu_data_master_debugaccess                       (cpu_data_master_debugaccess),                               //                                            .debugaccess
		.cpu_instruction_master_address                    (cpu_instruction_master_address),                            //                      cpu_instruction_master.address
		.cpu_instruction_master_waitrequest                (cpu_instruction_master_waitrequest),                        //                                            .waitrequest
		.cpu_instruction_master_read                       (cpu_instruction_master_read),                               //                                            .read
		.cpu_instruction_master_readdata                   (cpu_instruction_master_readdata),                           //                                            .readdata
		.cpu_instruction_master_readdatavalid              (cpu_instruction_master_readdatavalid),                      //                                            .readdatavalid
		.clock_crossing_io_slow_s0_address                 (mm_interconnect_0_clock_crossing_io_slow_s0_address),       //                   clock_crossing_io_slow_s0.address
		.clock_crossing_io_slow_s0_write                   (mm_interconnect_0_clock_crossing_io_slow_s0_write),         //                                            .write
		.clock_crossing_io_slow_s0_read                    (mm_interconnect_0_clock_crossing_io_slow_s0_read),          //                                            .read
		.clock_crossing_io_slow_s0_readdata                (mm_interconnect_0_clock_crossing_io_slow_s0_readdata),      //                                            .readdata
		.clock_crossing_io_slow_s0_writedata               (mm_interconnect_0_clock_crossing_io_slow_s0_writedata),     //                                            .writedata
		.clock_crossing_io_slow_s0_burstcount              (mm_interconnect_0_clock_crossing_io_slow_s0_burstcount),    //                                            .burstcount
		.clock_crossing_io_slow_s0_byteenable              (mm_interconnect_0_clock_crossing_io_slow_s0_byteenable),    //                                            .byteenable
		.clock_crossing_io_slow_s0_readdatavalid           (mm_interconnect_0_clock_crossing_io_slow_s0_readdatavalid), //                                            .readdatavalid
		.clock_crossing_io_slow_s0_waitrequest             (mm_interconnect_0_clock_crossing_io_slow_s0_waitrequest),   //                                            .waitrequest
		.clock_crossing_io_slow_s0_debugaccess             (mm_interconnect_0_clock_crossing_io_slow_s0_debugaccess),   //                                            .debugaccess
		.cpu_jtag_debug_module_address                     (mm_interconnect_0_cpu_jtag_debug_module_address),           //                       cpu_jtag_debug_module.address
		.cpu_jtag_debug_module_write                       (mm_interconnect_0_cpu_jtag_debug_module_write),             //                                            .write
		.cpu_jtag_debug_module_read                        (mm_interconnect_0_cpu_jtag_debug_module_read),              //                                            .read
		.cpu_jtag_debug_module_readdata                    (mm_interconnect_0_cpu_jtag_debug_module_readdata),          //                                            .readdata
		.cpu_jtag_debug_module_writedata                   (mm_interconnect_0_cpu_jtag_debug_module_writedata),         //                                            .writedata
		.cpu_jtag_debug_module_byteenable                  (mm_interconnect_0_cpu_jtag_debug_module_byteenable),        //                                            .byteenable
		.cpu_jtag_debug_module_waitrequest                 (mm_interconnect_0_cpu_jtag_debug_module_waitrequest),       //                                            .waitrequest
		.cpu_jtag_debug_module_debugaccess                 (mm_interconnect_0_cpu_jtag_debug_module_debugaccess),       //                                            .debugaccess
		.d5m_i2c_sclk_s1_address                           (mm_interconnect_0_d5m_i2c_sclk_s1_address),                 //                             d5m_i2c_sclk_s1.address
		.d5m_i2c_sclk_s1_write                             (mm_interconnect_0_d5m_i2c_sclk_s1_write),                   //                                            .write
		.d5m_i2c_sclk_s1_readdata                          (mm_interconnect_0_d5m_i2c_sclk_s1_readdata),                //                                            .readdata
		.d5m_i2c_sclk_s1_writedata                         (mm_interconnect_0_d5m_i2c_sclk_s1_writedata),               //                                            .writedata
		.d5m_i2c_sclk_s1_chipselect                        (mm_interconnect_0_d5m_i2c_sclk_s1_chipselect),              //                                            .chipselect
		.d5m_i2c_sdat_s1_address                           (mm_interconnect_0_d5m_i2c_sdat_s1_address),                 //                             d5m_i2c_sdat_s1.address
		.d5m_i2c_sdat_s1_write                             (mm_interconnect_0_d5m_i2c_sdat_s1_write),                   //                                            .write
		.d5m_i2c_sdat_s1_readdata                          (mm_interconnect_0_d5m_i2c_sdat_s1_readdata),                //                                            .readdata
		.d5m_i2c_sdat_s1_writedata                         (mm_interconnect_0_d5m_i2c_sdat_s1_writedata),               //                                            .writedata
		.d5m_i2c_sdat_s1_chipselect                        (mm_interconnect_0_d5m_i2c_sdat_s1_chipselect),              //                                            .chipselect
		.d5m_reset_n_s1_address                            (mm_interconnect_0_d5m_reset_n_s1_address),                  //                              d5m_reset_n_s1.address
		.d5m_reset_n_s1_write                              (mm_interconnect_0_d5m_reset_n_s1_write),                    //                                            .write
		.d5m_reset_n_s1_readdata                           (mm_interconnect_0_d5m_reset_n_s1_readdata),                 //                                            .readdata
		.d5m_reset_n_s1_writedata                          (mm_interconnect_0_d5m_reset_n_s1_writedata),                //                                            .writedata
		.d5m_reset_n_s1_chipselect                         (mm_interconnect_0_d5m_reset_n_s1_chipselect),               //                                            .chipselect
		.d5m_trigger_s1_address                            (mm_interconnect_0_d5m_trigger_s1_address),                  //                              d5m_trigger_s1.address
		.d5m_trigger_s1_write                              (mm_interconnect_0_d5m_trigger_s1_write),                    //                                            .write
		.d5m_trigger_s1_readdata                           (mm_interconnect_0_d5m_trigger_s1_readdata),                 //                                            .readdata
		.d5m_trigger_s1_writedata                          (mm_interconnect_0_d5m_trigger_s1_writedata),                //                                            .writedata
		.d5m_trigger_s1_chipselect                         (mm_interconnect_0_d5m_trigger_s1_chipselect),               //                                            .chipselect
		.epcq_epcs_control_port_address                    (mm_interconnect_0_epcq_epcs_control_port_address),          //                      epcq_epcs_control_port.address
		.epcq_epcs_control_port_write                      (mm_interconnect_0_epcq_epcs_control_port_write),            //                                            .write
		.epcq_epcs_control_port_read                       (mm_interconnect_0_epcq_epcs_control_port_read),             //                                            .read
		.epcq_epcs_control_port_readdata                   (mm_interconnect_0_epcq_epcs_control_port_readdata),         //                                            .readdata
		.epcq_epcs_control_port_writedata                  (mm_interconnect_0_epcq_epcs_control_port_writedata),        //                                            .writedata
		.epcq_epcs_control_port_chipselect                 (mm_interconnect_0_epcq_epcs_control_port_chipselect),       //                                            .chipselect
		.jtag_uart_avalon_jtag_slave_address               (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                 jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write                 (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),       //                                            .write
		.jtag_uart_avalon_jtag_slave_read                  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),        //                                            .read
		.jtag_uart_avalon_jtag_slave_readdata              (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                                            .readdata
		.jtag_uart_avalon_jtag_slave_writedata             (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                                            .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest           (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                                            .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect            (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  //                                            .chipselect
		.onchip_memory2_s1_address                         (mm_interconnect_0_onchip_memory2_s1_address),               //                           onchip_memory2_s1.address
		.onchip_memory2_s1_write                           (mm_interconnect_0_onchip_memory2_s1_write),                 //                                            .write
		.onchip_memory2_s1_readdata                        (mm_interconnect_0_onchip_memory2_s1_readdata),              //                                            .readdata
		.onchip_memory2_s1_writedata                       (mm_interconnect_0_onchip_memory2_s1_writedata),             //                                            .writedata
		.onchip_memory2_s1_byteenable                      (mm_interconnect_0_onchip_memory2_s1_byteenable),            //                                            .byteenable
		.onchip_memory2_s1_chipselect                      (mm_interconnect_0_onchip_memory2_s1_chipselect),            //                                            .chipselect
		.onchip_memory2_s1_clken                           (mm_interconnect_0_onchip_memory2_s1_clken)                  //                                            .clken
	);

	D5M_VIP_QSYS_mm_interconnect_1 mm_interconnect_1 (
		.pll_sys_outclk2_clk                                         (pll_sys_outclk2_clk),                            //                                       pll_sys_outclk2.clk
		.clock_crossing_io_slow_m0_reset_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                 // clock_crossing_io_slow_m0_reset_reset_bridge_in_reset.reset
		.clock_crossing_io_slow_m0_address                           (clock_crossing_io_slow_m0_address),              //                             clock_crossing_io_slow_m0.address
		.clock_crossing_io_slow_m0_waitrequest                       (clock_crossing_io_slow_m0_waitrequest),          //                                                      .waitrequest
		.clock_crossing_io_slow_m0_burstcount                        (clock_crossing_io_slow_m0_burstcount),           //                                                      .burstcount
		.clock_crossing_io_slow_m0_byteenable                        (clock_crossing_io_slow_m0_byteenable),           //                                                      .byteenable
		.clock_crossing_io_slow_m0_read                              (clock_crossing_io_slow_m0_read),                 //                                                      .read
		.clock_crossing_io_slow_m0_readdata                          (clock_crossing_io_slow_m0_readdata),             //                                                      .readdata
		.clock_crossing_io_slow_m0_readdatavalid                     (clock_crossing_io_slow_m0_readdatavalid),        //                                                      .readdatavalid
		.clock_crossing_io_slow_m0_write                             (clock_crossing_io_slow_m0_write),                //                                                      .write
		.clock_crossing_io_slow_m0_writedata                         (clock_crossing_io_slow_m0_writedata),            //                                                      .writedata
		.clock_crossing_io_slow_m0_debugaccess                       (clock_crossing_io_slow_m0_debugaccess),          //                                                      .debugaccess
		.key_s1_address                                              (mm_interconnect_1_key_s1_address),               //                                                key_s1.address
		.key_s1_write                                                (mm_interconnect_1_key_s1_write),                 //                                                      .write
		.key_s1_readdata                                             (mm_interconnect_1_key_s1_readdata),              //                                                      .readdata
		.key_s1_writedata                                            (mm_interconnect_1_key_s1_writedata),             //                                                      .writedata
		.key_s1_chipselect                                           (mm_interconnect_1_key_s1_chipselect),            //                                                      .chipselect
		.ledr_s1_address                                             (mm_interconnect_1_ledr_s1_address),              //                                               ledr_s1.address
		.ledr_s1_write                                               (mm_interconnect_1_ledr_s1_write),                //                                                      .write
		.ledr_s1_readdata                                            (mm_interconnect_1_ledr_s1_readdata),             //                                                      .readdata
		.ledr_s1_writedata                                           (mm_interconnect_1_ledr_s1_writedata),            //                                                      .writedata
		.ledr_s1_chipselect                                          (mm_interconnect_1_ledr_s1_chipselect),           //                                                      .chipselect
		.sw_s1_address                                               (mm_interconnect_1_sw_s1_address),                //                                                 sw_s1.address
		.sw_s1_write                                                 (mm_interconnect_1_sw_s1_write),                  //                                                      .write
		.sw_s1_readdata                                              (mm_interconnect_1_sw_s1_readdata),               //                                                      .readdata
		.sw_s1_writedata                                             (mm_interconnect_1_sw_s1_writedata),              //                                                      .writedata
		.sw_s1_chipselect                                            (mm_interconnect_1_sw_s1_chipselect),             //                                                      .chipselect
		.sysid_control_slave_address                                 (mm_interconnect_1_sysid_control_slave_address),  //                                   sysid_control_slave.address
		.sysid_control_slave_readdata                                (mm_interconnect_1_sysid_control_slave_readdata), //                                                      .readdata
		.timer_s1_address                                            (mm_interconnect_1_timer_s1_address),             //                                              timer_s1.address
		.timer_s1_write                                              (mm_interconnect_1_timer_s1_write),               //                                                      .write
		.timer_s1_readdata                                           (mm_interconnect_1_timer_s1_readdata),            //                                                      .readdata
		.timer_s1_writedata                                          (mm_interconnect_1_timer_s1_writedata),           //                                                      .writedata
		.timer_s1_chipselect                                         (mm_interconnect_1_timer_s1_chipselect)           //                                                      .chipselect
	);

	D5M_VIP_QSYS_mm_interconnect_2 mm_interconnect_2 (
		.pll_sys_outclk0_clk                             (pll_sys_outclk0_clk),                      //                           pll_sys_outclk0.clk
		.alt_vip_vfb_0_reset_reset_bridge_in_reset_reset (rst_controller_001_reset_out_reset),       // alt_vip_vfb_0_reset_reset_bridge_in_reset.reset
		.alt_vip_vfb_0_read_master_address               (alt_vip_vfb_0_read_master_address),        //                 alt_vip_vfb_0_read_master.address
		.alt_vip_vfb_0_read_master_waitrequest           (alt_vip_vfb_0_read_master_waitrequest),    //                                          .waitrequest
		.alt_vip_vfb_0_read_master_burstcount            (alt_vip_vfb_0_read_master_burstcount),     //                                          .burstcount
		.alt_vip_vfb_0_read_master_read                  (alt_vip_vfb_0_read_master_read),           //                                          .read
		.alt_vip_vfb_0_read_master_readdata              (alt_vip_vfb_0_read_master_readdata),       //                                          .readdata
		.alt_vip_vfb_0_read_master_readdatavalid         (alt_vip_vfb_0_read_master_readdatavalid),  //                                          .readdatavalid
		.alt_vip_vfb_0_write_master_address              (alt_vip_vfb_0_write_master_address),       //                alt_vip_vfb_0_write_master.address
		.alt_vip_vfb_0_write_master_waitrequest          (alt_vip_vfb_0_write_master_waitrequest),   //                                          .waitrequest
		.alt_vip_vfb_0_write_master_burstcount           (alt_vip_vfb_0_write_master_burstcount),    //                                          .burstcount
		.alt_vip_vfb_0_write_master_write                (alt_vip_vfb_0_write_master_write),         //                                          .write
		.alt_vip_vfb_0_write_master_writedata            (alt_vip_vfb_0_write_master_writedata),     //                                          .writedata
		.sdram_s1_address                                (mm_interconnect_2_sdram_s1_address),       //                                  sdram_s1.address
		.sdram_s1_write                                  (mm_interconnect_2_sdram_s1_write),         //                                          .write
		.sdram_s1_read                                   (mm_interconnect_2_sdram_s1_read),          //                                          .read
		.sdram_s1_readdata                               (mm_interconnect_2_sdram_s1_readdata),      //                                          .readdata
		.sdram_s1_writedata                              (mm_interconnect_2_sdram_s1_writedata),     //                                          .writedata
		.sdram_s1_byteenable                             (mm_interconnect_2_sdram_s1_byteenable),    //                                          .byteenable
		.sdram_s1_readdatavalid                          (mm_interconnect_2_sdram_s1_readdatavalid), //                                          .readdatavalid
		.sdram_s1_waitrequest                            (mm_interconnect_2_sdram_s1_waitrequest),   //                                          .waitrequest
		.sdram_s1_chipselect                             (mm_interconnect_2_sdram_s1_chipselect)     //                                          .chipselect
	);

	D5M_VIP_QSYS_irq_mapper irq_mapper (
		.clk           (pll_sys_outclk0_clk),                //       clk.clk
		.reset         (rst_controller_003_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),           // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),           // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),           // receiver2.irq
		.receiver3_irq (irq_mapper_receiver3_irq),           // receiver3.irq
		.receiver4_irq (irq_mapper_receiver4_irq),           // receiver4.irq
		.sender_irq    (cpu_d_irq_irq)                       //    sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer (
		.receiver_clk   (pll_sys_outclk2_clk),                //       receiver_clk.clk
		.sender_clk     (pll_sys_outclk0_clk),                //         sender_clk.clk
		.receiver_reset (rst_controller_reset_out_reset),     // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_receiver_irq),      //           receiver.irq
		.sender_irq     (irq_mapper_receiver0_irq)            //             sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer_001 (
		.receiver_clk   (clk_50),                             //       receiver_clk.clk
		.sender_clk     (pll_sys_outclk0_clk),                //         sender_clk.clk
		.receiver_reset (rst_controller_002_reset_out_reset), // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_001_receiver_irq),  //           receiver.irq
		.sender_irq     (irq_mapper_receiver1_irq)            //             sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer_002 (
		.receiver_clk   (pll_sys_outclk2_clk),                //       receiver_clk.clk
		.sender_clk     (pll_sys_outclk0_clk),                //         sender_clk.clk
		.receiver_reset (rst_controller_reset_out_reset),     // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_002_receiver_irq),  //           receiver.irq
		.sender_irq     (irq_mapper_receiver2_irq)            //             sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer_003 (
		.receiver_clk   (pll_sys_outclk2_clk),                //       receiver_clk.clk
		.sender_clk     (pll_sys_outclk0_clk),                //         sender_clk.clk
		.receiver_reset (rst_controller_reset_out_reset),     // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_003_receiver_irq),  //           receiver.irq
		.sender_irq     (irq_mapper_receiver3_irq)            //             sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_n),                       // reset_in0.reset
		.clk            (pll_sys_outclk2_clk),            //       clk.clk
		.reset_out      (rst_controller_reset_out_reset), // reset_out.reset
		.reset_req      (),                               // (terminated)
		.reset_req_in0  (1'b0),                           // (terminated)
		.reset_in1      (1'b0),                           // (terminated)
		.reset_req_in1  (1'b0),                           // (terminated)
		.reset_in2      (1'b0),                           // (terminated)
		.reset_req_in2  (1'b0),                           // (terminated)
		.reset_in3      (1'b0),                           // (terminated)
		.reset_req_in3  (1'b0),                           // (terminated)
		.reset_in4      (1'b0),                           // (terminated)
		.reset_req_in4  (1'b0),                           // (terminated)
		.reset_in5      (1'b0),                           // (terminated)
		.reset_req_in5  (1'b0),                           // (terminated)
		.reset_in6      (1'b0),                           // (terminated)
		.reset_req_in6  (1'b0),                           // (terminated)
		.reset_in7      (1'b0),                           // (terminated)
		.reset_req_in7  (1'b0),                           // (terminated)
		.reset_in8      (1'b0),                           // (terminated)
		.reset_req_in8  (1'b0),                           // (terminated)
		.reset_in9      (1'b0),                           // (terminated)
		.reset_req_in9  (1'b0),                           // (terminated)
		.reset_in10     (1'b0),                           // (terminated)
		.reset_req_in10 (1'b0),                           // (terminated)
		.reset_in11     (1'b0),                           // (terminated)
		.reset_req_in11 (1'b0),                           // (terminated)
		.reset_in12     (1'b0),                           // (terminated)
		.reset_req_in12 (1'b0),                           // (terminated)
		.reset_in13     (1'b0),                           // (terminated)
		.reset_req_in13 (1'b0),                           // (terminated)
		.reset_in14     (1'b0),                           // (terminated)
		.reset_req_in14 (1'b0),                           // (terminated)
		.reset_in15     (1'b0),                           // (terminated)
		.reset_req_in15 (1'b0)                            // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~reset_n),                               // reset_in0.reset
		.reset_in1      (cpu_jtag_debug_module_reset_reset),      // reset_in1.reset
		.clk            (pll_sys_outclk0_clk),                    //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_001_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_002 (
		.reset_in0      (~reset_n),                           // reset_in0.reset
		.reset_in1      (cpu_jtag_debug_module_reset_reset),  // reset_in1.reset
		.clk            (clk_50),                             //       clk.clk
		.reset_out      (rst_controller_002_reset_out_reset), // reset_out.reset
		.reset_req      (),                                   // (terminated)
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_003 (
		.reset_in0      (~reset_n),                               // reset_in0.reset
		.clk            (pll_sys_outclk0_clk),                    //       clk.clk
		.reset_out      (rst_controller_003_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_003_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_in1      (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_004 (
		.reset_in0      (~reset_n),                           // reset_in0.reset
		.clk            (clk_50),                             //       clk.clk
		.reset_out      (rst_controller_004_reset_out_reset), // reset_out.reset
		.reset_req      (),                                   // (terminated)
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

endmodule
