
module D5M_VIP_QSYS (
	clk_50,
	reset_n,
	zs_addr_from_the_sdram,
	zs_ba_from_the_sdram,
	zs_cas_n_from_the_sdram,
	zs_cke_from_the_sdram,
	zs_cs_n_from_the_sdram,
	zs_dq_to_and_from_the_sdram,
	zs_dqm_from_the_sdram,
	zs_ras_n_from_the_sdram,
	zs_we_n_from_the_sdram,
	clk_sdram_clk,
	clk_vga_clk,
	ledr_external_connection_export,
	key_external_connection_export,
	sw_external_connection_export,
	alt_vip_itc_0_clocked_video_vid_clk,
	alt_vip_itc_0_clocked_video_vid_data,
	alt_vip_itc_0_clocked_video_underflow,
	alt_vip_itc_0_clocked_video_vid_datavalid,
	alt_vip_itc_0_clocked_video_vid_v_sync,
	alt_vip_itc_0_clocked_video_vid_h_sync,
	alt_vip_itc_0_clocked_video_vid_f,
	alt_vip_itc_0_clocked_video_vid_h,
	alt_vip_itc_0_clocked_video_vid_v,
	d5m_conduit_end_D,
	d5m_conduit_end_FVAL,
	d5m_conduit_end_LVAL,
	d5m_conduit_end_PIXCLK,
	d5m_xclkin_clk,
	d5m_i2c_sclk_external_connection_export,
	d5m_i2c_sdat_external_connection_export,
	d5m_trigger_external_connection_export,
	d5m_reset_n_external_connection_export);	

	input		clk_50;
	input		reset_n;
	output	[12:0]	zs_addr_from_the_sdram;
	output	[1:0]	zs_ba_from_the_sdram;
	output		zs_cas_n_from_the_sdram;
	output		zs_cke_from_the_sdram;
	output		zs_cs_n_from_the_sdram;
	inout	[15:0]	zs_dq_to_and_from_the_sdram;
	output	[1:0]	zs_dqm_from_the_sdram;
	output		zs_ras_n_from_the_sdram;
	output		zs_we_n_from_the_sdram;
	output		clk_sdram_clk;
	output		clk_vga_clk;
	output	[9:0]	ledr_external_connection_export;
	input	[3:0]	key_external_connection_export;
	input	[9:0]	sw_external_connection_export;
	input		alt_vip_itc_0_clocked_video_vid_clk;
	output	[23:0]	alt_vip_itc_0_clocked_video_vid_data;
	output		alt_vip_itc_0_clocked_video_underflow;
	output		alt_vip_itc_0_clocked_video_vid_datavalid;
	output		alt_vip_itc_0_clocked_video_vid_v_sync;
	output		alt_vip_itc_0_clocked_video_vid_h_sync;
	output		alt_vip_itc_0_clocked_video_vid_f;
	output		alt_vip_itc_0_clocked_video_vid_h;
	output		alt_vip_itc_0_clocked_video_vid_v;
	input	[11:0]	d5m_conduit_end_D;
	input		d5m_conduit_end_FVAL;
	input		d5m_conduit_end_LVAL;
	input		d5m_conduit_end_PIXCLK;
	output		d5m_xclkin_clk;
	output		d5m_i2c_sclk_external_connection_export;
	inout		d5m_i2c_sdat_external_connection_export;
	output		d5m_trigger_external_connection_export;
	output		d5m_reset_n_external_connection_export;
endmodule
